# Creating the driver
from selenium import webdriver
from selenium.webdriver.chrome.service import Service
# for headless mode
from selenium.webdriver.chrome.options import Options
import time
import pandas as pd
from selenium.webdriver.common.by import By


def get_files():
    # for headless mode 
    options=Options()
    options.headless=True
    path="./chromedriver"
    # Use the services from 
    service = Service(executable_path=path)

    # # To define the driver
    driver = webdriver.Chrome(service=service,options=options) # for headless use 'options=options'

    # driver.get(website)
    print('\nReading the csv files with Plan Names and Links')
    links_df=pd.read_csv('plans_links_filetypejson.csv', sep=';')

    # checking the basic idea
    # Go to the link, and search for machine readable files and click them to download if possible
    checked_href=[]
    file_check=0
    for i in range(2,len(links_df)-1):
        file_name=links_df.iloc[i,0]
        source=links_df.iloc[i,1]
        try:
            print(f"Going to the source link = {source}\n...")
            driver.get(source)
            print(f"Finding all a tags...\n")
            link=driver.find_elements(By.TAG_NAME, value='a')
            for j in link:
                link_value=j.get_attribute('href')
                checked_href.append(link_value)
                str_value =str(link_value)
                if str_value.endswith('.json') or str_value.endswith('.csv') or str_value.endswith('.xlsx'):
    #             if '.json' in link_value or '.csv' in link_value or 'xlsx' in link_value:
                    print(f"Found a file link = {link_value}")
                    link_value.click()
                    print(f"Link Cliked... \nNext")
            print(f"Plan Name==> {links_df[i,0]} Checked for all the links\nNext Plan Name\n")
            file_check+=1
        except Exception as err:
            print(f"Unexpected {err}, {type(err)=}")
            continue
            raise
            print("Moving to next link for Plan Name")
        
    print(f"Checked for files ={file_check//4}")
    print("Quiting the headless browser...")

    driver.quit()   
    # link.find_elements(By.TAG_NAME,'a')
    # link.click()




if __name__ == "__main__":
    print('Running the script...')
    print(get_files())
    
